require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__ARM_KVM_H__)) {
    eval 'sub __ARM_KVM_H__ () {1;}' unless defined(&__ARM_KVM_H__);
    require 'linux/types.ph';
    require 'linux/psci.ph';
    require 'asm/ptrace.ph';
    eval 'sub __KVM_HAVE_GUEST_DEBUG () {1;}' unless defined(&__KVM_HAVE_GUEST_DEBUG);
    eval 'sub __KVM_HAVE_IRQ_LINE () {1;}' unless defined(&__KVM_HAVE_IRQ_LINE);
    eval 'sub __KVM_HAVE_READONLY_MEM () {1;}' unless defined(&__KVM_HAVE_READONLY_MEM);
    eval 'sub KVM_COALESCED_MMIO_PAGE_OFFSET () {1;}' unless defined(&KVM_COALESCED_MMIO_PAGE_OFFSET);
    eval 'sub KVM_REG_SIZE {
        my($id) = @_;
	    eval q((1 << ((($id) &  &KVM_REG_SIZE_MASK) >>  &KVM_REG_SIZE_SHIFT)));
    }' unless defined(&KVM_REG_SIZE);
    eval 'sub KVM_ARM_SVC_sp () { $svc_regs[0];}' unless defined(&KVM_ARM_SVC_sp);
    eval 'sub KVM_ARM_SVC_lr () { $svc_regs[1];}' unless defined(&KVM_ARM_SVC_lr);
    eval 'sub KVM_ARM_SVC_spsr () { $svc_regs[2];}' unless defined(&KVM_ARM_SVC_spsr);
    eval 'sub KVM_ARM_ABT_sp () { $abt_regs[0];}' unless defined(&KVM_ARM_ABT_sp);
    eval 'sub KVM_ARM_ABT_lr () { $abt_regs[1];}' unless defined(&KVM_ARM_ABT_lr);
    eval 'sub KVM_ARM_ABT_spsr () { $abt_regs[2];}' unless defined(&KVM_ARM_ABT_spsr);
    eval 'sub KVM_ARM_UND_sp () { $und_regs[0];}' unless defined(&KVM_ARM_UND_sp);
    eval 'sub KVM_ARM_UND_lr () { $und_regs[1];}' unless defined(&KVM_ARM_UND_lr);
    eval 'sub KVM_ARM_UND_spsr () { $und_regs[2];}' unless defined(&KVM_ARM_UND_spsr);
    eval 'sub KVM_ARM_IRQ_sp () { $irq_regs[0];}' unless defined(&KVM_ARM_IRQ_sp);
    eval 'sub KVM_ARM_IRQ_lr () { $irq_regs[1];}' unless defined(&KVM_ARM_IRQ_lr);
    eval 'sub KVM_ARM_IRQ_spsr () { $irq_regs[2];}' unless defined(&KVM_ARM_IRQ_spsr);
    eval 'sub KVM_ARM_FIQ_r8 () { $fiq_regs[0];}' unless defined(&KVM_ARM_FIQ_r8);
    eval 'sub KVM_ARM_FIQ_r9 () { $fiq_regs[1];}' unless defined(&KVM_ARM_FIQ_r9);
    eval 'sub KVM_ARM_FIQ_r10 () { $fiq_regs[2];}' unless defined(&KVM_ARM_FIQ_r10);
    eval 'sub KVM_ARM_FIQ_fp () { $fiq_regs[3];}' unless defined(&KVM_ARM_FIQ_fp);
    eval 'sub KVM_ARM_FIQ_ip () { $fiq_regs[4];}' unless defined(&KVM_ARM_FIQ_ip);
    eval 'sub KVM_ARM_FIQ_sp () { $fiq_regs[5];}' unless defined(&KVM_ARM_FIQ_sp);
    eval 'sub KVM_ARM_FIQ_lr () { $fiq_regs[6];}' unless defined(&KVM_ARM_FIQ_lr);
    eval 'sub KVM_ARM_FIQ_spsr () { $fiq_regs[7];}' unless defined(&KVM_ARM_FIQ_spsr);
    eval 'sub KVM_ARM_TARGET_CORTEX_A15 () {0;}' unless defined(&KVM_ARM_TARGET_CORTEX_A15);
    eval 'sub KVM_ARM_TARGET_CORTEX_A7 () {1;}' unless defined(&KVM_ARM_TARGET_CORTEX_A7);
    eval 'sub KVM_ARM_NUM_TARGETS () {2;}' unless defined(&KVM_ARM_NUM_TARGETS);
    eval 'sub KVM_ARM_DEVICE_TYPE_SHIFT () {0;}' unless defined(&KVM_ARM_DEVICE_TYPE_SHIFT);
    eval 'sub KVM_ARM_DEVICE_TYPE_MASK () {(0xffff <<  &KVM_ARM_DEVICE_TYPE_SHIFT);}' unless defined(&KVM_ARM_DEVICE_TYPE_MASK);
    eval 'sub KVM_ARM_DEVICE_ID_SHIFT () {16;}' unless defined(&KVM_ARM_DEVICE_ID_SHIFT);
    eval 'sub KVM_ARM_DEVICE_ID_MASK () {(0xffff <<  &KVM_ARM_DEVICE_ID_SHIFT);}' unless defined(&KVM_ARM_DEVICE_ID_MASK);
    eval 'sub KVM_ARM_DEVICE_VGIC_V2 () {0;}' unless defined(&KVM_ARM_DEVICE_VGIC_V2);
    eval 'sub KVM_VGIC_V2_ADDR_TYPE_DIST () {0;}' unless defined(&KVM_VGIC_V2_ADDR_TYPE_DIST);
    eval 'sub KVM_VGIC_V2_ADDR_TYPE_CPU () {1;}' unless defined(&KVM_VGIC_V2_ADDR_TYPE_CPU);
    eval 'sub KVM_VGIC_V2_DIST_SIZE () {0x1000;}' unless defined(&KVM_VGIC_V2_DIST_SIZE);
    eval 'sub KVM_VGIC_V2_CPU_SIZE () {0x2000;}' unless defined(&KVM_VGIC_V2_CPU_SIZE);
    eval 'sub KVM_VGIC_V3_ADDR_TYPE_DIST () {2;}' unless defined(&KVM_VGIC_V3_ADDR_TYPE_DIST);
    eval 'sub KVM_VGIC_V3_ADDR_TYPE_REDIST () {3;}' unless defined(&KVM_VGIC_V3_ADDR_TYPE_REDIST);
    eval 'sub KVM_VGIC_ITS_ADDR_TYPE () {4;}' unless defined(&KVM_VGIC_ITS_ADDR_TYPE);
    eval 'sub KVM_VGIC_V3_DIST_SIZE () { &SZ_64K;}' unless defined(&KVM_VGIC_V3_DIST_SIZE);
    eval 'sub KVM_VGIC_V3_REDIST_SIZE () {(2*  &SZ_64K);}' unless defined(&KVM_VGIC_V3_REDIST_SIZE);
    eval 'sub KVM_VGIC_V3_ITS_SIZE () {(2*  &SZ_64K);}' unless defined(&KVM_VGIC_V3_ITS_SIZE);
    eval 'sub KVM_ARM_VCPU_POWER_OFF () {0;}' unless defined(&KVM_ARM_VCPU_POWER_OFF);
    eval 'sub KVM_ARM_VCPU_PSCI_0_2 () {1;}' unless defined(&KVM_ARM_VCPU_PSCI_0_2);
    eval 'sub KVM_REG_ARM_COPROC_MASK () {0xfff0000;}' unless defined(&KVM_REG_ARM_COPROC_MASK);
    eval 'sub KVM_REG_ARM_COPROC_SHIFT () {16;}' unless defined(&KVM_REG_ARM_COPROC_SHIFT);
    eval 'sub KVM_REG_ARM_32_OPC2_MASK () {0x7;}' unless defined(&KVM_REG_ARM_32_OPC2_MASK);
    eval 'sub KVM_REG_ARM_32_OPC2_SHIFT () {0;}' unless defined(&KVM_REG_ARM_32_OPC2_SHIFT);
    eval 'sub KVM_REG_ARM_OPC1_MASK () {0x78;}' unless defined(&KVM_REG_ARM_OPC1_MASK);
    eval 'sub KVM_REG_ARM_OPC1_SHIFT () {3;}' unless defined(&KVM_REG_ARM_OPC1_SHIFT);
    eval 'sub KVM_REG_ARM_CRM_MASK () {0x780;}' unless defined(&KVM_REG_ARM_CRM_MASK);
    eval 'sub KVM_REG_ARM_CRM_SHIFT () {7;}' unless defined(&KVM_REG_ARM_CRM_SHIFT);
    eval 'sub KVM_REG_ARM_32_CRN_MASK () {0x7800;}' unless defined(&KVM_REG_ARM_32_CRN_MASK);
    eval 'sub KVM_REG_ARM_32_CRN_SHIFT () {11;}' unless defined(&KVM_REG_ARM_32_CRN_SHIFT);
    eval 'sub ARM_CP15_REG_SHIFT_MASK {
        my($x,$n) = @_;
	    eval q(((($x) <<  &KVM_REG_ARM_  $n   &_SHIFT) &  &KVM_REG_ARM_  $n   &_MASK));
    }' unless defined(&ARM_CP15_REG_SHIFT_MASK);
    eval 'sub __ARM_CP15_REG {
        my($op1,$crn,$crm,$op2) = @_;
	    eval q(( &KVM_REG_ARM | (15<<  &KVM_REG_ARM_COPROC_SHIFT) |  &ARM_CP15_REG_SHIFT_MASK($op1,  &OPC1) |  &ARM_CP15_REG_SHIFT_MASK($crn, 32 &_CRN) |  &ARM_CP15_REG_SHIFT_MASK($crm,  &CRM) |  &ARM_CP15_REG_SHIFT_MASK($op2, 32 &_OPC2)));
    }' unless defined(&__ARM_CP15_REG);
    eval 'sub ARM_CP15_REG32 () {(...) ( &__ARM_CP15_REG( &__VA_ARGS__) |  &KVM_REG_SIZE_U32);}' unless defined(&ARM_CP15_REG32);
    eval 'sub __ARM_CP15_REG64 {
        my($op1,$crm) = @_;
	    eval q(( &__ARM_CP15_REG($op1, 0, $crm, 0) |  &KVM_REG_SIZE_U64));
    }' unless defined(&__ARM_CP15_REG64);
    eval 'sub ARM_CP15_REG64 () {(...)  &__ARM_CP15_REG64( &__VA_ARGS__);}' unless defined(&ARM_CP15_REG64);
    eval 'sub KVM_REG_ARM_PTIMER_CTL () { &ARM_CP15_REG32(0, 14, 2, 1);}' unless defined(&KVM_REG_ARM_PTIMER_CTL);
    eval 'sub KVM_REG_ARM_PTIMER_CNT () { &ARM_CP15_REG64(0, 14);}' unless defined(&KVM_REG_ARM_PTIMER_CNT);
    eval 'sub KVM_REG_ARM_PTIMER_CVAL () { &ARM_CP15_REG64(2, 14);}' unless defined(&KVM_REG_ARM_PTIMER_CVAL);
    eval 'sub KVM_REG_ARM_TIMER_CTL () { &ARM_CP15_REG32(0, 14, 3, 1);}' unless defined(&KVM_REG_ARM_TIMER_CTL);
    eval 'sub KVM_REG_ARM_TIMER_CNT () { &ARM_CP15_REG64(1, 14);}' unless defined(&KVM_REG_ARM_TIMER_CNT);
    eval 'sub KVM_REG_ARM_TIMER_CVAL () { &ARM_CP15_REG64(3, 14);}' unless defined(&KVM_REG_ARM_TIMER_CVAL);
    eval 'sub KVM_REG_ARM_CORE () {(0x10 <<  &KVM_REG_ARM_COPROC_SHIFT);}' unless defined(&KVM_REG_ARM_CORE);
    eval 'sub KVM_REG_ARM_CORE_REG {
        my($name) = @_;
	    eval q(( &offsetof(\'struct kvm_regs\', $name) / 4));
    }' unless defined(&KVM_REG_ARM_CORE_REG);
    eval 'sub KVM_REG_ARM_DEMUX () {(0x11 <<  &KVM_REG_ARM_COPROC_SHIFT);}' unless defined(&KVM_REG_ARM_DEMUX);
    eval 'sub KVM_REG_ARM_DEMUX_ID_MASK () {0xff00;}' unless defined(&KVM_REG_ARM_DEMUX_ID_MASK);
    eval 'sub KVM_REG_ARM_DEMUX_ID_SHIFT () {8;}' unless defined(&KVM_REG_ARM_DEMUX_ID_SHIFT);
    eval 'sub KVM_REG_ARM_DEMUX_ID_CCSIDR () {(0x <<  &KVM_REG_ARM_DEMUX_ID_SHIFT);}' unless defined(&KVM_REG_ARM_DEMUX_ID_CCSIDR);
    eval 'sub KVM_REG_ARM_DEMUX_VAL_MASK () {0xff;}' unless defined(&KVM_REG_ARM_DEMUX_VAL_MASK);
    eval 'sub KVM_REG_ARM_DEMUX_VAL_SHIFT () {0;}' unless defined(&KVM_REG_ARM_DEMUX_VAL_SHIFT);
    eval 'sub KVM_REG_ARM_VFP () {(0x12 <<  &KVM_REG_ARM_COPROC_SHIFT);}' unless defined(&KVM_REG_ARM_VFP);
    eval 'sub KVM_REG_ARM_VFP_MASK () {0xffff;}' unless defined(&KVM_REG_ARM_VFP_MASK);
    eval 'sub KVM_REG_ARM_VFP_BASE_REG () {0x;}' unless defined(&KVM_REG_ARM_VFP_BASE_REG);
    eval 'sub KVM_REG_ARM_VFP_FPSID () {0x1000;}' unless defined(&KVM_REG_ARM_VFP_FPSID);
    eval 'sub KVM_REG_ARM_VFP_FPSCR () {0x1001;}' unless defined(&KVM_REG_ARM_VFP_FPSCR);
    eval 'sub KVM_REG_ARM_VFP_MVFR1 () {0x1006;}' unless defined(&KVM_REG_ARM_VFP_MVFR1);
    eval 'sub KVM_REG_ARM_VFP_MVFR0 () {0x1007;}' unless defined(&KVM_REG_ARM_VFP_MVFR0);
    eval 'sub KVM_REG_ARM_VFP_FPEXC () {0x1008;}' unless defined(&KVM_REG_ARM_VFP_FPEXC);
    eval 'sub KVM_REG_ARM_VFP_FPINST () {0x1009;}' unless defined(&KVM_REG_ARM_VFP_FPINST);
    eval 'sub KVM_REG_ARM_VFP_FPINST2 () {0x100a;}' unless defined(&KVM_REG_ARM_VFP_FPINST2);
    eval 'sub KVM_DEV_ARM_VGIC_GRP_ADDR () {0;}' unless defined(&KVM_DEV_ARM_VGIC_GRP_ADDR);
    eval 'sub KVM_DEV_ARM_VGIC_GRP_DIST_REGS () {1;}' unless defined(&KVM_DEV_ARM_VGIC_GRP_DIST_REGS);
    eval 'sub KVM_DEV_ARM_VGIC_GRP_CPU_REGS () {2;}' unless defined(&KVM_DEV_ARM_VGIC_GRP_CPU_REGS);
    eval 'sub KVM_DEV_ARM_VGIC_CPUID_SHIFT () {32;}' unless defined(&KVM_DEV_ARM_VGIC_CPUID_SHIFT);
    eval 'sub KVM_DEV_ARM_VGIC_CPUID_MASK () {(0xff <<  &KVM_DEV_ARM_VGIC_CPUID_SHIFT);}' unless defined(&KVM_DEV_ARM_VGIC_CPUID_MASK);
    eval 'sub KVM_DEV_ARM_VGIC_V3_MPIDR_SHIFT () {32;}' unless defined(&KVM_DEV_ARM_VGIC_V3_MPIDR_SHIFT);
    eval 'sub KVM_DEV_ARM_VGIC_V3_MPIDR_MASK () {(0xffffffff <<  &KVM_DEV_ARM_VGIC_V3_MPIDR_SHIFT);}' unless defined(&KVM_DEV_ARM_VGIC_V3_MPIDR_MASK);
    eval 'sub KVM_DEV_ARM_VGIC_OFFSET_SHIFT () {0;}' unless defined(&KVM_DEV_ARM_VGIC_OFFSET_SHIFT);
    eval 'sub KVM_DEV_ARM_VGIC_OFFSET_MASK () {(0xffffffff <<  &KVM_DEV_ARM_VGIC_OFFSET_SHIFT);}' unless defined(&KVM_DEV_ARM_VGIC_OFFSET_MASK);
    eval 'sub KVM_DEV_ARM_VGIC_SYSREG_INSTR_MASK () {(0xffff);}' unless defined(&KVM_DEV_ARM_VGIC_SYSREG_INSTR_MASK);
    eval 'sub KVM_DEV_ARM_VGIC_GRP_NR_IRQS () {3;}' unless defined(&KVM_DEV_ARM_VGIC_GRP_NR_IRQS);
    eval 'sub KVM_DEV_ARM_VGIC_GRP_CTRL () {4;}' unless defined(&KVM_DEV_ARM_VGIC_GRP_CTRL);
    eval 'sub KVM_DEV_ARM_VGIC_GRP_REDIST_REGS () {5;}' unless defined(&KVM_DEV_ARM_VGIC_GRP_REDIST_REGS);
    eval 'sub KVM_DEV_ARM_VGIC_GRP_CPU_SYSREGS () {6;}' unless defined(&KVM_DEV_ARM_VGIC_GRP_CPU_SYSREGS);
    eval 'sub KVM_DEV_ARM_VGIC_GRP_LEVEL_INFO () {7;}' unless defined(&KVM_DEV_ARM_VGIC_GRP_LEVEL_INFO);
    eval 'sub KVM_DEV_ARM_VGIC_GRP_ITS_REGS () {8;}' unless defined(&KVM_DEV_ARM_VGIC_GRP_ITS_REGS);
    eval 'sub KVM_DEV_ARM_VGIC_LINE_LEVEL_INFO_SHIFT () {10;}' unless defined(&KVM_DEV_ARM_VGIC_LINE_LEVEL_INFO_SHIFT);
    eval 'sub KVM_DEV_ARM_VGIC_LINE_LEVEL_INFO_MASK () {(0x3fffff <<  &KVM_DEV_ARM_VGIC_LINE_LEVEL_INFO_SHIFT);}' unless defined(&KVM_DEV_ARM_VGIC_LINE_LEVEL_INFO_MASK);
    eval 'sub KVM_DEV_ARM_VGIC_LINE_LEVEL_INTID_MASK () {0x3ff;}' unless defined(&KVM_DEV_ARM_VGIC_LINE_LEVEL_INTID_MASK);
    eval 'sub VGIC_LEVEL_INFO_LINE_LEVEL () {0;}' unless defined(&VGIC_LEVEL_INFO_LINE_LEVEL);
    eval 'sub KVM_ARM_VCPU_PMU_V3_CTRL () {0;}' unless defined(&KVM_ARM_VCPU_PMU_V3_CTRL);
    eval 'sub KVM_ARM_VCPU_PMU_V3_IRQ () {0;}' unless defined(&KVM_ARM_VCPU_PMU_V3_IRQ);
    eval 'sub KVM_ARM_VCPU_PMU_V3_INIT () {1;}' unless defined(&KVM_ARM_VCPU_PMU_V3_INIT);
    eval 'sub KVM_ARM_VCPU_TIMER_CTRL () {1;}' unless defined(&KVM_ARM_VCPU_TIMER_CTRL);
    eval 'sub KVM_ARM_VCPU_TIMER_IRQ_VTIMER () {0;}' unless defined(&KVM_ARM_VCPU_TIMER_IRQ_VTIMER);
    eval 'sub KVM_ARM_VCPU_TIMER_IRQ_PTIMER () {1;}' unless defined(&KVM_ARM_VCPU_TIMER_IRQ_PTIMER);
    eval 'sub KVM_DEV_ARM_VGIC_CTRL_INIT () {0;}' unless defined(&KVM_DEV_ARM_VGIC_CTRL_INIT);
    eval 'sub KVM_DEV_ARM_ITS_SAVE_TABLES () {1;}' unless defined(&KVM_DEV_ARM_ITS_SAVE_TABLES);
    eval 'sub KVM_DEV_ARM_ITS_RESTORE_TABLES () {2;}' unless defined(&KVM_DEV_ARM_ITS_RESTORE_TABLES);
    eval 'sub KVM_DEV_ARM_VGIC_SAVE_PENDING_TABLES () {3;}' unless defined(&KVM_DEV_ARM_VGIC_SAVE_PENDING_TABLES);
    eval 'sub KVM_DEV_ARM_ITS_CTRL_RESET () {4;}' unless defined(&KVM_DEV_ARM_ITS_CTRL_RESET);
    eval 'sub KVM_ARM_IRQ_TYPE_SHIFT () {24;}' unless defined(&KVM_ARM_IRQ_TYPE_SHIFT);
    eval 'sub KVM_ARM_IRQ_TYPE_MASK () {0xff;}' unless defined(&KVM_ARM_IRQ_TYPE_MASK);
    eval 'sub KVM_ARM_IRQ_VCPU_SHIFT () {16;}' unless defined(&KVM_ARM_IRQ_VCPU_SHIFT);
    eval 'sub KVM_ARM_IRQ_VCPU_MASK () {0xff;}' unless defined(&KVM_ARM_IRQ_VCPU_MASK);
    eval 'sub KVM_ARM_IRQ_NUM_SHIFT () {0;}' unless defined(&KVM_ARM_IRQ_NUM_SHIFT);
    eval 'sub KVM_ARM_IRQ_NUM_MASK () {0xffff;}' unless defined(&KVM_ARM_IRQ_NUM_MASK);
    eval 'sub KVM_ARM_IRQ_TYPE_CPU () {0;}' unless defined(&KVM_ARM_IRQ_TYPE_CPU);
    eval 'sub KVM_ARM_IRQ_TYPE_SPI () {1;}' unless defined(&KVM_ARM_IRQ_TYPE_SPI);
    eval 'sub KVM_ARM_IRQ_TYPE_PPI () {2;}' unless defined(&KVM_ARM_IRQ_TYPE_PPI);
    eval 'sub KVM_ARM_IRQ_CPU_IRQ () {0;}' unless defined(&KVM_ARM_IRQ_CPU_IRQ);
    eval 'sub KVM_ARM_IRQ_CPU_FIQ () {1;}' unless defined(&KVM_ARM_IRQ_CPU_FIQ);
    eval 'sub KVM_ARM_IRQ_GIC_MAX () {127;}' unless defined(&KVM_ARM_IRQ_GIC_MAX);
    eval 'sub KVM_NR_IRQCHIPS () {1;}' unless defined(&KVM_NR_IRQCHIPS);
    eval 'sub KVM_PSCI_FN_BASE () {0x95c1ba5e;}' unless defined(&KVM_PSCI_FN_BASE);
    eval 'sub KVM_PSCI_FN {
        my($n) = @_;
	    eval q(( &KVM_PSCI_FN_BASE + ($n)));
    }' unless defined(&KVM_PSCI_FN);
    eval 'sub KVM_PSCI_FN_CPU_SUSPEND () { &KVM_PSCI_FN(0);}' unless defined(&KVM_PSCI_FN_CPU_SUSPEND);
    eval 'sub KVM_PSCI_FN_CPU_OFF () { &KVM_PSCI_FN(1);}' unless defined(&KVM_PSCI_FN_CPU_OFF);
    eval 'sub KVM_PSCI_FN_CPU_ON () { &KVM_PSCI_FN(2);}' unless defined(&KVM_PSCI_FN_CPU_ON);
    eval 'sub KVM_PSCI_FN_MIGRATE () { &KVM_PSCI_FN(3);}' unless defined(&KVM_PSCI_FN_MIGRATE);
    eval 'sub KVM_PSCI_RET_SUCCESS () { &PSCI_RET_SUCCESS;}' unless defined(&KVM_PSCI_RET_SUCCESS);
    eval 'sub KVM_PSCI_RET_NI () { &PSCI_RET_NOT_SUPPORTED;}' unless defined(&KVM_PSCI_RET_NI);
    eval 'sub KVM_PSCI_RET_INVAL () { &PSCI_RET_INVALID_PARAMS;}' unless defined(&KVM_PSCI_RET_INVAL);
    eval 'sub KVM_PSCI_RET_DENIED () { &PSCI_RET_DENIED;}' unless defined(&KVM_PSCI_RET_DENIED);
}
1;
